'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var axios = require('axios');

function _interopDefault (e) { return e && e.__esModule ? e : { 'default': e }; }

function _interopNamespace(e) {
  if (e && e.__esModule) return e;
  var n = Object.create(null);
  if (e) {
    Object.keys(e).forEach(function (k) {
      if (k !== 'default') {
        var d = Object.getOwnPropertyDescriptor(e, k);
        Object.defineProperty(n, k, d.get ? d : {
          enumerable: true,
          get: function () {
            return e[k];
          }
        });
      }
    });
  }
  n['default'] = e;
  return Object.freeze(n);
}

var axios__default = /*#__PURE__*/_interopDefault(axios);

const defaults = {
  async request(param) {
    const enableSuperjson = param.meta && param.meta.superjson;

    try {
      var _response$headers, _response$headers$con;

      const response = await axios__default['default']({
        baseURL: defaults.baseURL,
        ...param
      });

      if ((response === null || response === void 0 ? void 0 : (_response$headers = response.headers) === null || _response$headers === void 0 ? void 0 : (_response$headers$con = _response$headers['content-type']) === null || _response$headers$con === void 0 ? void 0 : _response$headers$con.indexOf('application/json')) !== -1 && enableSuperjson && response !== null && response !== void 0 && response.data) {
        const superjson = await Promise.resolve().then(function () { return /*#__PURE__*/_interopNamespace(require('superjson')); });
        return superjson.deserialize(response.data);
      }

      return response === null || response === void 0 ? void 0 : response.data;
    } catch (error) {
      var _e$response;

      const e = error;

      if (enableSuperjson && e !== null && e !== void 0 && (_e$response = e.response) !== null && _e$response !== void 0 && _e$response.data) {
        const superjson = await Promise.resolve().then(function () { return /*#__PURE__*/_interopNamespace(require('superjson')); });
        throw superjson.deserialize(e.response.data);
      }

      throw e;
    }
  },

  baseURL: ''
};
function request(param) {
  return defaults.request(param);
}

exports.defaults = defaults;
exports.request = request;
